aboutsummaryrefslogtreecommitdiff
path: root/bash/bash_completion.d/sd.bash
diff options
context:
space:
mode:
authorTom Ryder <tom@sanctum.geek.nz>2018-12-02 23:12:15 +1300
committerTom Ryder <tom@sanctum.geek.nz>2018-12-02 23:12:15 +1300
commit456ccb394342528e1d3a8e17277a51039c9c2549 (patch)
tree7d85c2282553762caa50c6d675c97709d51d2c2b /bash/bash_completion.d/sd.bash
parentMerge branch 'release/v2.7.0' (diff)
parentBump VERSION (diff)
downloaddotfiles-2.8.0.tar.gz (sig)
dotfiles-2.8.0.zip
Merge branch 'release/v2.8.0'v2.8.0
* release/v2.8.0: Bump VERSION Use native filename quoting for td(1df) complete Make bd() and sd() match quoted and unquoted words Remove unneeded braces Use variable for node count, not expansion Use simple loop rather than glob tricks in keep Move error increment to outside of if block Add missing source of helper func to man complete Remove unneeded local var Trim some trailing whitespace Correct manpath(1) command in man completion Adjust quoting and termination for man completion Update glob settings for manual page completion Make `sec` a local var in man page completion Remove unneeded `local` declaration Reorder pattern filters for Makefile lines Add some comments to keep() completion Correct find(1) completion to subshell exit Correct completion quoting for eds(1df)
Diffstat (limited to 'bash/bash_completion.d/sd.bash')
-rw-r--r--bash/bash_completion.d/sd.bash28
1 files changed, 19 insertions, 9 deletions
diff --git a/bash/bash_completion.d/sd.bash b/bash/bash_completion.d/sd.bash
index 66dea73b..4dc72f31 100644
--- a/bash/bash_completion.d/sd.bash
+++ b/bash/bash_completion.d/sd.bash
@@ -15,18 +15,28 @@ _sd() {
# Make globs expand appropriately
shopt -s dotglob nullglob
if _completion_ignore_case ; then
- shopt -s nocaseglob
+ shopt -s nocasematch 2>/dev/null
fi
# Print matching sibling dirs that are not the current dir
- for sibling in ../"$2"*/ ; do
- sibling=${sibling%/}
- sibling=${sibling#../}
- case $sibling in
- ("${PWD##*/}") ;;
- (*) printf '%q/' "${sibling}" ;;
- esac
+ for sib in ../*/ ; do
+ # Strip leading ../
+ sib=${sib#../}
+ # Strip trailing slash
+ sib=${sib%/}
+ # Skip self
+ [[ $sib != "${PWD##*/}" ]] || continue
+ # Check the quoted and unquoted word for matching
+ for match in "$sib" "$(printf '%q' "$sib")" ; do
+ # Print any match, slash-terminated
+ case $match in
+ ("$2"*)
+ printf '%s/' "$sib"
+ continue
+ ;;
+ esac
+ done
done
)
}
-complete -F _sd sd
+complete -F _sd -o filenames sd